// test nokia lcd nxp in thai
#include <NewSoftSerial.h>
#include <TinyGPS.h>
#include <Nokia_lcd.h>

#include <avr/pgmspace.h>
#include <stdio.h>

Nokia_lcd lcd=Nokia_lcd();

TinyGPS gps;
NewSoftSerial nss(2, 3);

void InitPort(){
  DDRB=0x2F;
}

void setup(void) {
  Serial.begin(115200);
  nss.begin(9600);
  
  InitPort();
  LCD_BACKLIGHT(1);
  lcd.cLCD_Init();

  lcd.cLCD_Box(0,0,131,131,FILL,WHITE);
  lcd.cLCD_ThaiString(" Tiny GPS test ", 1, 1, WHITE, BLUE); 
  lcd.cLCD_ThaiString("Lat :", 1, 15, BLACK ,WHITE);
  lcd.cLCD_ThaiString("long :", 1, 30, BLACK ,WHITE);
        
  lcd.cLCD_ThaiString("ҿѹͷ", 10, 110, RED ,WHITE);
  lcd.cLCD_ThaiString("www.ayarafun.com", 18, 120, RED ,WHITE);    
}

void loop(void)
{
  char buffer[16];

  long lat, lon;
  unsigned long age;
  int year;
  byte month, day, hour, minute, second, hundredths;

  bool newdata = false;
  unsigned long start = millis();

  while (millis() - start < 500)
  {
    if (feedgps())
      newdata = true;
  }
  
  if (newdata)  {    
      gps.get_position(&lat, &lon, &age);      
      Serial.print("Lat/Long(10^-4 deg): "); Serial.print(lat); Serial.print(", "); Serial.print(lon); 
      Serial.print(" Fix age: "); Serial.print(age); Serial.println("ms.");      
             
      gps.crack_datetime(&year, &month, &day, &hour, &minute, &second, &hundredths, &age);
      //Serial.print("Date: "); Serial.print(static_cast<int>(month)); Serial.print("/"); Serial.print(static_cast<int>(day)); Serial.print("/"); Serial.print(year);
      //Serial.print("  Time: "); Serial.print(static_cast<int>(hour)); Serial.print(":"); Serial.print(static_cast<int>(minute)); Serial.print(":"); Serial.print(static_cast<int>(second)); Serial.print("."); Serial.print(static_cast<int>(hundredths));
      //Serial.print("  Fix age: ");  Serial.print(age); Serial.println("ms.");

      lcd.cLCD_ThaiString( ltoa(lat , buffer ,10) , 40, 15, BLACK ,WHITE);    
      lcd.cLCD_ThaiString( ltoa(lon , buffer ,10) , 40, 30, BLACK ,WHITE);
      
      sprintf (buffer,"DATE : %d/%d/%d",static_cast<int>(day),static_cast<int>(month),static_cast<int>(year));      
      lcd.cLCD_ThaiString( buffer , 1, 45, BLACK ,WHITE);
      
      sprintf (buffer,"[UTC] : %d:%d:%d.%d   ",hour,minute,second,hundredths);
      lcd.cLCD_ThaiString( buffer , 1, 60, BLACK ,WHITE);
           
      //sprintf (buffer16,"[BKK] %d:%d:%d    ",(hour+7),minute,second);      
      //lcd.cLCD_ThaiString( buffer16 , 1, 75, BLACK ,WHITE);                        
  }
  
}

bool feedgps()
{
  while (nss.available())
  {
    if (gps.encode(nss.read()))
      return true;
  }
  return false;
}

